# Copyright (C) 2004 - 2007 by Jens Wilke jens at wilke dot org
# Copyright (C) 2003 Michael Spiceland
# This script is released under the GNU GPL license.  Please
# see the included LICENSE file for details.
#
# This library is free software; you can redistribute it and/or modify it under
# the terms of the GNU Library General Public License as published by the Free
# Software Foundation; either version 2.1 of the License, or (at your option)
# any later version.
#
# This library is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
# more details.
#
# You should have received a copy of the GNU Library General Public License
# along with this library; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307  USA.

sub printpage($){
	my $content = $_[0];
	my $template = $_[1];
	my $page;
	open(TEMPLATE,"<$template")||dienice("could not find the template file template.html to use!");
	while(<TEMPLATE>){
		$page .= $_;
	}
	close(TEMPLATE);
	$page =~ s/<!-- ?CONTENT ?-->/$content<br><font color='#000000' size=-1>
Powered by <a color='#008800' href="http:\/\/www.fuzzymonkey.org\/newfuzzy\/software\/perl\/" target=\"new\">My Photo Gallery $version<\/a>.  Licensed under <a href=\"http:\/\/www.fsf.org\/copyleft\/gpl.html\" target=\"newwindow\">GPL<\/a>. &#169; 2000-2003 Fuzzymonkey.org.<\/font><br>/i;
	print "Content-type: text/html\n\n$page";
}; # "

sub dienice {
	my($msg) = @_;
	print <<HTML;
	$msg
    If you continue to have problems, email jens\@wilke.org
HTML
	exit;
}

sub prettytime {
	#converts the first argument as the number of seconds since Jan1,1970 into a readable string
	# and returns it.
	@days = ("Sun","Mon","Tues","Wed","Thur","Fri","Sat","Sun");
	@months = ("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
	($sec,$min,$hr,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($_[0]);
	$longyr = $year + 1900;
	$fixmo = $mon + 1;
	
	if($hr > 12)  {
		$hr = $hr - 12;
		$ampm = "PM";
	} else {
		$ampm = "AM";
	}
	
	$yr2 = substr($longyr,2,2);
	
	$time = sprintf("%02s %02d, %04d",
                          $months[$mon],$mday,$longyr);
	return $time;
	
}

sub checkdirectories($) {
	my $return = 1;
	my $selectedalbum = $_[0];

	#make thumbnails directory if it doesn't exist
	unless(-e "$dataroot/$selectedalbum/thumbnails"){
        #print "Making directory $photoroot/$selectedalbum/thumbnails ...<br><br>";
		if(! mkdir("$dataroot/$selectedalbum/thumbnails",0755)){ $return = 0}
	}
	
	#make comments directory if it doesn't exist
	unless(-e "$dataroot/$selectedalbum/descriptions"){
        #print "Making directory $photoroot/$selectedalbum/descriptions...<br><br>";
		if(! mkdir("$dataroot/$selectedalbum/descriptions",0755)){$return = 0}
	}
	return $return;
}


#########################################################################
# prints out a trail to the selected album with hyperlinks to view them #
#########################################################################
sub print_location ($) {
    my $return;
    $return .= "$title: <a href=\"index.cgi\">main</a> ";
	@steps = split (/\//,"$_[0]");
	foreach $step (@steps){
		if($not_the_first){$sofar .= "/$step";}else{$sofar .= "$step";}
		$not_the_first = 1;
		$return .="<a href=\"index.cgi?mode=view&album=$sofar\">$step</a> > ";
	}
    $return .= "<br>\n";
    $return .= "<br>\n";
    return $return;
}

sub fileinfo {
	($dev,$ino,$mode,$nlink,$uid,$guid,$rdev,$filesize,$atime,$mtime,$ctime,$blksize,$blocks) = stat $_[0];
	if($filesize > 1024*1024){
		$kfilesize = sprintf("%0.1f M",$filesize/1024/1024);
	}else{
		$kfilesize = sprintf("%d K",$filesize/1024);
	}
	$time = prettytime($mtime);
}


########################################################################################
##  Sends an email using 5 variables $subject, $to, $from, $etitle, $body in @_#########
########################################################################################
sub email ($$$$$) 
{ 
    my ($subject, $to, $from, $etitle, $body) = @_;

    open (MAIL, "| $sendmail -oi -t" ) || dienice("could not open mail");
    print MAIL <<MAIL_MESSAGE;
Subject:$subject
To:$to
Reply-to:$from
From:$etitle
$body
MAIL_MESSAGE
     close MAIL;
}

sub filetype {
		my $file = $_[0];
# 		_utf8_off($file);
# 		$file = encode($enc, $file);
		$file = '"'.$file.'"';
# 		$file =~ s/(\/+)/\//g;
 		#$file =~ s/ /\\ /g;

		my $type = `file -b $file | cut -f1 -d' '`;

		chomp($type);
		$type = lc($type);
		if($d){print"File $file Filetype is <$type>\n"}
		return $type;
}

return 1;

   
package Gtk2::CellRendererSpinButton;
# Copyright (C) 2003 by Torsten Schoenfeld, with minor hacks by muppet.
# $Header: /cvsroot/gtk2-perl/gtk2-perl-xs/Gtk2/examples/cellrenderer_spinbutton.pl,v 1.3 2004/02/04 07:14:53 muppetman Exp $
use POSIX qw(DBL_MAX UINT_MAX);

use constant x_padding => 2;
use constant y_padding => 3;

use Glib::Object::Subclass
  "Gtk2::CellRenderer",
  signals => {
    edited => {
      flags => [qw(run-last)],
      param_types => [qw(Glib::String Glib::Double)],
    },
  },
  properties => [
    Glib::ParamSpec -> double("xalign", "Horizontal Alignment", "Where am i?", 0.0, 1.0, 1.0, [qw(readable writable)]),
    Glib::ParamSpec -> boolean("editable", "Editable", "Can I change that?", 0, [qw(readable writable)]),
    Glib::ParamSpec -> uint("digits", "Digits", "How picky are you?", 0, UINT_MAX, 2, [qw(readable writable)]),
    map {
      Glib::ParamSpec -> double($_ -> [0],
                                $_ -> [1],
                                $_ -> [2],
                                0.0,
                                DBL_MAX,
                                $_ -> [3],
                                [qw(readable writable)])
    } (["value", "Value", "How much is the fish?",      0.0],
       ["min",   "Min",   "No way, I have to live!",    0.0],
       ["max",   "Max",   "Ah, you're too generous.", 100.0],
       ["step",  "Step",  "Okay.",                      5.0])
  ]
;

sub INIT_INSTANCE {
	my $self = shift;
	$self->{editable} = 0;
	$self->{digits}   = 2;
	$self->{value}    =   0.0;
	$self->{min}      =   0.0;
	$self->{max}      = 100.0;
	$self->{step}     =   5.0;
	$self->{xalign}   =   1.0;
}

sub calc_size {
  my ($cell, $layout, $area) = @_;
  my ($width, $height) = $layout -> get_pixel_size();

  return ($area ? $cell->{xalign} * ($area->width - ($width + 3 * x_padding)) : 0,
          0,
          $width + x_padding * 2,
           $height + y_padding * 2
	  );
}

sub format_text {
	my $cell = shift;
	my $format = sprintf '%%.%df', $cell->{digits};
	sprintf $format, $cell->{value};
}

sub GET_SIZE {
  my ($cell, $widget, $area) = @_;

  my $layout = $cell -> get_layout($widget);
  $layout -> set_text($cell -> format_text);

  return $cell -> calc_size($layout, $area);
}

sub get_layout {
  my ($cell, $widget) = @_;

  return $widget -> create_pango_layout("");
}

sub RENDER {
  my ($cell, $window, $widget, $background_area, $cell_area, $expose_area, $flags) = @_;
  my $state;
  my $requisition = $widget->size_request;
	if ($cell->{show_box}) {
		$widget->get_style->paint_box ($window, $widget->state,
					 'out', $cell_area,
					 undef, "optionmenu",
					 $cell_area->x,
					 $cell_area->y + ($cell_area->height - $requisition->height) / 2,
					 # $cell_area->y + $cell_area->height / 2 - 14,
					 $cell_area->width,
					 # 30
					 $requisition->height);
					 # 
	}
  if ($flags & 'selected') {
    $state = $widget -> has_focus()
      ? 'selected'
      : 'active';
  } else {
    $state = $widget -> state() eq 'insensitive'
      ? 'insensitive'
      : 'normal';
  }

  my $layout = $cell -> get_layout($widget);
  $layout -> set_text ($cell -> format_text);

  my ($x_offset, $y_offset, $width, $height) =
  		$cell -> calc_size($layout, $cell_area);
  $widget -> get_style -> paint_layout($window,
                                       $state,
                                       1,
                                       $cell_area,
                                       $widget,
                                       "cellrenderertext",
                                        $cell_area -> x() + $width,
                                        $cell_area -> y() + ($cell_area -> height / 2) - 7,
#					  $cell_area -> x() + $x_offset + x_padding,
#                                        $cell_area -> y() + $y_offset + y_padding,
                                       $layout);
}

sub START_EDITING {
  my ($cell, $event, $view, $path, $background_area, $cell_area, $flags) = @_;
  
  #if($d){print "start editing: <$cell, $event, $view, $path, $background_area, $cell_area, $flags>\n";}
  
  my $spin_button = Gtk2::SpinButton -> new_with_range($cell -> get(qw(min max step)));

  $spin_button -> set_value($cell -> get("value"));
  $spin_button -> set_digits($cell -> get("digits"));
   
   my $requisition = $spin_button->size_request;
  #$cell_area -> y( $cell_area -> y + ($cell_area -> height - $requisition->height) / 2);
  #$cell_area -> y( $cell_area -> y + ($cell_area -> height - $requisition->height) / 2);
  #$cell_area->height ($requisition->height);
  #$cell_area->height (10);
  my $layout = $cell -> get_layout($spin_button);
  $layout -> set_text ($cell -> format_text);

  my ($x_offset, $y_offset, $width, $height) =
  		$cell -> calc_size($layout, $cell_area);
  
  $spin_button -> grab_focus();
  
  $spin_button->{_focus_out_id} =
  $spin_button -> signal_connect(focus_out_event => sub {
     my (undef, $event) = @_;
     $cell -> _editing_done ($path, $spin_button -> get_value());
     # the spinbutton needs the focus-out event, don't eat it.
     return 0;
   });
  
 $spin_button -> signal_connect(key_press_event => sub {
    my ($event_box, $event) = @_;
    if ($event -> keyval == $Gtk2::Gdk::Keysyms{ Return } ||
        $event -> keyval == $Gtk2::Gdk::Keysyms{ KP_Enter }) {
      $spin_button -> update();
      $cell -> signal_emit(edited => $path, $spin_button -> get_value());
      $spin_button -> destroy();
      return 1;
    }
    
    if ($event -> keyval == $Gtk2::Gdk::Keysyms{ Up }) {
      $spin_button -> spin('step-forward', ($spin_button -> get_increments())[0]);
      return 1;
    }
    elsif ($event -> keyval == $Gtk2::Gdk::Keysyms{ Down }) {
      $spin_button -> spin('step-backward', ($spin_button -> get_increments())[0]);
      return 1;
    }    
    
    return 0;
  });

  $spin_button -> show_all();

  return $spin_button;
}
 
sub _editing_done {
    my ($self, $path, $new_value) = @_;
    if ($self->{_focus_out_id}) {
      $self->signal_handler_disconnect ($self->{_focus_out_id});
      delete $self->{_focus_out_id};
    }
    $self->signal_emit('edited', $path, $new_value);
}

package Mup::CellRendererPopup;
#
# Copyright (C) 2003 by muppet
#
# $Header: /cvsroot/gtk2-perl/gtk2-perl-xs/Gtk2/examples/cellrenderer_popup.pl,v 1.7 2004/03/26 02:17:06 muppetman Exp $
#
use strict;

use Glib::Object::Subclass
	Gtk2::CellRenderer::,
	signals => {
		edited => {
			flags => [qw/run-last/],
			#                  path         index
			param_types => [qw/Glib::String Glib::Int/],
		},
	},
	properties => [
		Glib::ParamSpec->boolean ('show_box', 'Show Box',
		                          '',
					  1, ['readable', 'writable']),
		Glib::ParamSpec->boolean ('editable', 'Editable',
		                          '',
					  0, ['readable', 'writable']),
 		Glib::ParamSpec->int ('index', 'Index',
 		                      '',
 				      0, 65535, 0, [qw/readable writable/]),
 		Glib::ParamSpec->boxed ('list', 'List',
 		                        '',
					'Glib::Scalar',
 				        [qw/readable writable/]),
	],
	;

use Data::Dumper;

use constant xpad => 3;
use constant ypad => 2;
# arrow will use text height
use constant arrow_width => 15;

sub INIT_INSTANCE {
	my $self = shift;
	$self->{show_box} = 1;
}

sub calc_size {
	my ($cell, $layout) = @_;
	my ($w, $h) = $layout->get_pixel_size;
	#return (0, 0, $w + xpad * 2 + arrow_width, $h + ypad * 2);
	return (0, 0, $w + xpad * 2 + arrow_width, 10);
}

sub GET_SIZE {
	my ($cell, $widget, $area) = @_;
	if ($area) {
		return (3, 3, $area->width - arrow_width - 2*xpad - 4, $area->height - 9);
	}
	my $layout = $cell->get_layout ($widget);
	$layout->set_text ($cell->{list}[$cell->{index}] || "");
	return $cell->calc_size ($layout);
}

sub get_layout {
	my ($cell, $widget) = @_;
	return $cell->{layout} if defined $cell->{layout};
	return $cell->{layout} = $widget->create_pango_layout ("");
}

sub RENDER {
	my ($cell, $drawable, $widget, $background_area, $cell_area, $expose_area, $flags) = @_;
	my $state = 'normal';

# 	if ($cell->{show_box}) {
# 		$widget->get_style->paint_box ($drawable, $widget->state,
# 					 'out', $cell_area,
# 					 undef, "optionmenu",
# 					 $cell_area->x ,
# 					 $cell_area->y + $cell_area->height / 2 - 15,
# 					 # $cell_area->y,
# 					 $cell_area->width,
# 					 30);
# 	} else {
		if ($flags & 'selected') {
			$state = $widget->has_focus
			       ? 'selected'
			       : 'active';
		} else {
			$state = $widget->state eq 'insensitive'
			       ? 'insensitive'
			       : 'normal';
		}
# 	}

	my $layout = $cell->get_layout ($widget);
	$layout->set_text ($cell->{list}[$cell->{index}] || "");
	my ($xoff, $yoff, $width, $height) = $cell->calc_size ($layout);
        # my $requisition = $widget->size_request;
	
	$widget->get_style->paint_layout ($drawable,
				 $state,
			         1, $cell_area,
				 $widget, "cellrenderertext",
                                 $cell_area->x + $xoff + xpad,
# 				 $cell_area->y + $yoff + ypad,
 				 $cell_area->y + $yoff + ypad + $cell_area->height / 2 - 8,
				 $layout);
	$widget->get_style->paint_arrow ($drawable, $state, 'none',
				$cell_area, $widget, "",
				'down', 0,
				$cell_area->x+$cell_area->width - arrow_width +2 ,
#                                 $cell_area->y+$cell_area->height - ($cell_area->height - 2) - 2,
                                $cell_area->y+$cell_area->height - ($cell_area->height - 2) -2,
				arrow_width - 3, $cell_area->height - 2);
}

sub menu_pos_func {
	my ($menu, $x, $y, $data) = @_;
	my ($treeview, $cell_area) = @$data;
	my ($wx, $wy) = $treeview->get_bin_window->get_origin;
        my ($tx, $ty) = $treeview->tree_to_widget_coords($cell_area->x, $cell_area->y);
	my $visible = $treeview->get_visible_rect;

        $x = $wx + $visible->x + $tx + xpad;
#         $y = $wy + $visible->y + $ty + $cell_area->height / 2 ;
        $y = $wy + $visible->y + $ty + $cell_area->height / 2 - 2;

	# 	$cell_area->y + $cell_area->height / 2 -15,
	
	# $x = $wx + $tx + xpad;
	# $y = $wy + $ty + $cell_area->height / 2 - 2;
	
	# center the menu vertically around the selected item.
	# this is inspired heavily by GtkOptionMenu.
	my $active = $menu->get_active;
	$y -= $active->get_child_requisition->height / 2 if $active;
	foreach my $i ($menu->get_children) {
		last if $i == $active;
		$y -= $i->get_child_requisition->height if $i->visible;
	}
	# play nicely with rtl languages
	if ($treeview->get_direction eq 'rtl') {
		$x = $wx + $tx + $cell_area->width -
			$menu->get_child_requisition->width;
	}
	return ($x, $y, 1);
}

sub editing_done {
	my ($item, $info) = @_;
	my ($cell, $editable) = @$info;
# 	if($d){print"editing_done item $item info $info cell $cell editable $editable\n
# 		item->{path} $item->{path} item->{index} $item->{index}\n"}
	$cell->signal_emit ('edited', $item->{path}, $item->{index});

	# see the evil trick description below
	$editable->remove_widget;
}

sub START_EDITING {
	my ($cell, $event, $widget, $path, $background_area, $cell_area, $flags) = @_;
	my $menu = Gtk2::Menu->new;
	my @data = @{ $cell->{list} };
	# if($d){print"START_EDITING cell: $cell data: @data\n"}
	# my @data = ('9 x 13','10 x 15','13 x 18','20 x 30');
	# @{ $cell->{list} = @data;
	# this is an evil trick.  we're creating a custom widget and handling
	# the editing ourselves, but the higher level code only thinks we're
	# editing if we return an editable.  so we return an editable.  of
	# course, we have to remove it in the menu activate callbacks so that
	# it doesn't stick around.
	my $editable = Gtk2::Entry->new;
	# my @j = @data;
	for (my $i = 0 ; $i < @data ; $i++) {
		my $item = Gtk2::MenuItem->new ($data[$i]);
		$item->show;
		$menu->append ($item);
		$item->{path} = $path;
		$item->{index} = $i;
		$item->{text} = $data[$i];
		# $item->signal_connect (activate => \&editing_done, $cell);
		$item->signal_connect (activate => \&editing_done, [$cell, $editable]);
	}
	$menu->set_active($cell->{index});
	#if($d){print"menu->set_active: menu $menu cell $cell->{index}\n"}
	$menu->popup (undef, undef,
	              \&menu_pos_func, [$widget, $cell_area],
	              $event ? $event->button : 0, 0);
	my $item = $menu->get_active;
	$menu->select_item($item) if $item;

	# see the evil trick mentioned above.
	$editable;
}