#!/usr/bin/perl

# Copyright (c) 2004 - 2007 by Jens Wilke 
# This script is released under the GPL license.  Please
# see the included LICENSE file for details.

use strict;
use LWP::UserAgent;
use LWP::ConnCache;
use HTTP::Request::Common;
use HTTP::Cookies;
use MIME::Base64;
use HTML::Display;

use vars qw( $f_lb1 );
require "GGvars.pl";

use vars qw( $lib $d $photoroot $dataroot %filetypes $exif $version);
if(-e "$ENV{HOME}/.gtkgallery/sitevariables"){
   require "$ENV{HOME}/.gtkgallery/sitevariables"}
else {
   require "/etc/gtkgallery/sitevariables";}
require "$lib/imagemagick.pl";

sub restrans2 {

   my ($lab, $or_list) = @_; 
   my @or_list = @$or_list;
   #my ($i, $j, $size);
   print "restrans2 started with lab <$lab>\nunsorted list:\t<@or_list>\n" if $d;
1;
 }
 
sub restrans {

   my ($lab, $obutton, $or_list) = @_; 
   my @or_list = @$or_list;
   my ($i, $j, $size);
   print "restrans started with lab <$lab>\nunsorted list:\t<@or_list>\n" if $d;
   my $anz = $#or_list;
   print "anz: $anz\n" if $d;
   print "INFO \nINFO ------------------- upload log -------------------\n";
   print "INFO  $l_ul1". ($anz + 1) ." $l_ul2 $lab.\n";
   my @sorted = sort {$a->[6] cmp $b->[6] || $b->[0] <=> $a->[0] } @or_list;
   #  || $a->[1] cmp $b->[1]   $b->[0] <=> $a->[0] 
   if($d){print "sorted list:\t@sorted\n"}
   @or_list = @sorted;
	 
   for ($j=0; $j <= $anz; $j++){
   	#_utf8_on($or_list[$j][6]);
	if ($d){print "checking $or_list[$j][6] size $or_list[$j][0]\n";}
	print "INFO preparing $or_list[$j][6] size $or_list[$j][0]\n";
	#_utf8_off($or_list[$j][6]);
	# sizes:  11 x: 1809
	# 	    21 x: 2494
     if	($anz == 0 || $or_list[$j][6] ne $or_list[$j-1][6]){	 
	if ($d){print "prozessing it\n"}
	if ($or_list[$j][0] < 2){$size = 1809}
	if (($or_list[$j][0] == 2)||($or_list[$j][0] == 3)){$size = 2494}
	my $file = $or_list[$j][6];
	$file =~ s/\/([^\/]+)$/\/$size\/$1/g;
	unless(-e "$dataroot$file"){
		&resize("$or_list[$j][6]","$file",$size);
	}else{
		print "$dataroot$file already exists\n" if $d;
	}
	
	# create a new field for @or_list, containing the uploadable pics
	# if $or_list[$j][7] is empty, file was already uploaded
	# $or_list[$j][0] > 3 upload the full image
	
	if ($or_list[$j][0] > 3){
	    if($d){print"setting $or_list[$j][7] = $photoroot$or_list[$j][6] \n"}
	   $or_list[$j][7] = $photoroot.$or_list[$j][6]}
	else {
	   #if($d){print"setting $or_list[$j][7] = $dataroot$file \n"}
	   $or_list[$j][7] = $dataroot.$file; 
	   if($d){print"or_list field: $or_list[$j][7] \n"}
	}

      }	
   } # end for

	if($lab eq $f_lb1){ &trans_fkde(\@or_list) }
}

sub trans_fkde {

  my ($or_list) = @_;
#  my ($or_list, $dialog1, $label1) = @_;

  my @or_list = @$or_list;
  if($d){print "starting trans_fkde mit \@or_list @or_list\n"}
  my ($uurl);
  
  my $ua = LWP::UserAgent->new(agent => 'GTK-Gallery');
  # $ua->max_size([$bytes])
  my $cache = $ua->conn_cache(LWP::ConnCache->new( ));
  $ua->conn_cache->total_capacity(undef);
  #$ua->cookie_jar(HTTP::Cookies->new(file => "/tmp/gtkgallerycookies.txt", autosave => 1));
     # Create a request
  my $req = HTTP::Request->new(POST => 'http://upload.fotokasten.de/upload/getserverurl.php?');
    $req->content_type('multipart/form-data');
  $req->content('');
    # Pass request to the user agent and get a response back
  my $res = $ua->request($req);
  print $res->code."\n" if $d;
  print "header_field_names: ".$res->header_field_names . "\n" if $d;
  print "header: ".$res->as_string ."\n" if $d;
  if(($res->code != 200) && ($res->code != 302)){
  	# error or offline
	print "INFO $l_err ";
	if($res->content){
		print $res->content."\n";
	}else{
		print "http://upload.fotokasten.de code: ".$res->code."\n";
	}
	print "INFO $l_e6\n";
	print "pipe: set ok-button sensitive\n";
	#$obutton->set_sensitive(1); # TODO debug, this doesn't work
	return;
  }
  if($d){
      print "$res->content" .$res->content ." \n";
      print "$res->code" .$res->code ." \n";
      print "$res->headers" .$res->headers ." \n";
   }
   my $h = $res->headers;
   my $url = $h->header('Location');
   $url =~ s/([^=]+)=(.+)&/$2/g;
   my @hfn = $h->header_field_names;

   if($d){   print "hfn: <@hfn>\n url: <$url> \n";}
  # Check the outcome of the response
  if($url){
    print "INFO $l_ul3: $url\n";
    my $purl = $url.'upload/registersession.php3?';
    $req = HTTP::Request->new(GET => "$purl");
    $req->content_type('multipart/form-data');
    $req->content('vcode=1758');
    # Pass request to the user agent and get a response back
    $res = $ua->request($req);
  } else {print "INFO $l_err $l_e5 $l_e6\n"; print "0\n"; return 1;}
   $h = $res->headers;
   if($d){
      print $res->content."\n";
      print $res->code."\n";
      print $res->message; print "\n";
      print $res->headers."\n";
      print $h->header('Client-Warning')."\n";
   }

   my $err = substr( $h->header('Location'), -2, 2 );
   if($err ne '=0') {print "INFO $l_err $l_e7: <$err>\n$l_e6\n"; print "0\n"; return 1;}
   
   my $sid = $h->header('Location');
   $sid =~ s/([^=]+)=(.+)&(.+)/$2/g;
   @hfn = $h->header_field_names;
   if($d){   print "hfn: <@hfn> sid: <$sid>  \$err: <$err>\n"};
   if($sid){
    print "INFO Session ID $sid\n";
    my $anz = $#or_list;
    my (@ua, @res);
    $uurl = $url.'upload/upload.php3?'; # upload URL
    print "anz: $anz \n";
    my $fc = ($anz + 1);
    for (my $j=0; $j <= $anz; $j++){
	      my $name= $or_list[$j][7];
	      if($d){print "checking <$name> \n"}
	      if (-e $name){
		 if($d){print"open filehandle $name\n"}
		$ua[$j] = $ua->clone();
		 if($d){print "new user agent is <$ua[$j]>\n";}
		 
		 # load up
		_utf8_on($name);
		print "INFO Going to upload $name.\n";
		 $res[$j] = $ua[$j]->post("$uurl", ['vcode' => '1758', 'sid' => "$sid", 'filecount' => "$fc", "datei$j" => ["$name"] ],
		 					'Content_Type' => 'multipart/form-data;boundary=--------071904092013630', 'Accept' => "text/html, */*", 'Connection' => 'keep-alive');
		$h = $res[$j]->headers;
		print "INFO $l_don\n";
	     	 }
      		}
		 my $answ1 = $h->header('Location');
		 my $sid1 = $answ1;
		 $sid1 =~ s/([^=]+)=(.+)&(.+)/$2/g;
		 $uurl = $url.'upload/list.php3?';
		 $req = HTTP::Request->new(GET => "$uurl");
             	 $req->content_type('application/x-www-form-urlencoded');
		 $req->content("sid=$sid");
		 $res = $ua->request($req);
		 
		 my $answ2 = $h->header('Location');
		 print "INFO Upload $l_don.\n";
		 
	     	 if($d){	
      			print $res->content."\n";
      			print $res->code."\n";
      			print $res->message; print "\n";
      			print $res->headers."\n";
   			$h = $res->headers;
			print $h->header('Client-Warning')."\n";
   			#$sid = $h->header('Location');
   			#$sid =~ s/([^=]+)=(.+)&(.+)/$2/g;
   			@hfn = $h->header_field_names;
   			print "hfn: <@hfn> sid: <$sid>\n";
			# $answ2 = $h->header('Location');
			print "answ1: $answ1 \n";
			print "sid1: $sid1\n";
		#	print "answ2: $answ2 \n";
		#	print "sid2: $sid2\n";
		#	print "answ3: $answ3 \n";
     	      }
   
   } else {
   	print "INFO $l_err: $l_e8 $l_e6\n"; 
	print "0\n"; 
	print "$l_err: $l_e8\n" if $d; 
	return 1;
   }
   
    my $lang = substr($ENV{LANG}, 0, 2);
    if(($lang ne "de")&&($lang ne "fr")&&($lang ne "se")&&($lang ne "nl")){$lang = "en"}
    my $burl = $url.'upload/list.php3?vcode=1758&sid='.$sid.'&language='.$lang.'&datei=list.php3';
    chomp($burl);
    print "INFO $l_ul4:\n";
    print "INFO $burl\n";
    &browser($burl);
    1;
}

sub browser {
	my $burl = $_[0];
	my $err;
#	# fork again, to make shure, that the GUI doesn't hang
 	if (my $pid = fork) {
 		return 1;
 	}elsif (defined $pid) { 
	
# 	if (my $pid = open(CHILD2, "-|")) {
# 	    	chomp(my $line = <CHILD2>);
#     		print "Parent Pid $$ just read this: <$line>\n";
# 		print "$line\n";
#     		close(CHILD2);
# 		return 1;
# 	} else {
# 	    	die "cannot fork: $!" unless defined $pid;
# 	    	STDOUT->autoflush(1);
		#Gtk2->main_iteration while Gtk2->events_pending; # crashes
		if($d){print "I'm trying  to open <$burl> in a browser now.\n";     }
		#setsid( );
# 		my $browser = HTML::Display->new();
# 		$browser->display(location => $burl);
# 		
# 		exit;
		my $firefox = `which firefox`; chomp($firefox);
		my $mozilla = `which mozilla`; chomp($mozilla);
       		if($d){print "found firefox <$firefox>\n"}
       		# if (! $firefox){ }
		if($d){print "found mozilla <$mozilla>\n"}
       		#if (-e $mozilla) {
 		my $me = `whoami`;
# 		
# 		my $ff_pid = `ps -U $me | grep firefox-bin | cut -f1 -d ' '`;
# 		my $run_ff =`ps --no-heading -o "%a" $ff_pid`;
# 		my $mo_pid = `ps -U $me | grep mozilla-bin | cut -f1 -d ' '`;
# 		my $run_mo =`ps --no-heading -o "%a" $mo_pid`;
# 		$run_ff =~ s/firefox-bin$/firefox/g;
# 		$run_mo =~ s/mozilla-bin$/mozilla/g;
# 		print "found running: moz <$run_mo>, ff <$run_ff>\n" if $d;
# 		if(($run_mo) && ($run_mo eq $mozilla)){
# 			# mozilla running and correct binary found
# 			print "INFO Open URL in new Mozilla Tab\n";
# 			$err = `$mozilla -remote "openurl($burl,new-tab)"`;
# 		}elsif(($run_ff) && ($run_ff eq $firefox)){
# 			# firefox running and correct binary found
# 			print "INFO Open URL in new Firefox Tab\n";
# 			$err = `$firefox -remote "openurl($burl,new-tab)"`;
# 		}else{
# 			# start new browser with open not to wait for that process
# 			
# 		# if((! grep(/mozilla-bin/,`ps -U $me`)) && (! grep(/firefox-bin/, `ps -U $me`))){
# 			print "INFO Mozilla or Firefox are not running, starting new: \n";
# 			if($mozilla){
# 				print "INFO Mozilla\n";
# 				open(MOZILLA, "| $mozilla");
# 				$err = $!;
# 			}elsif($firefox){
# 				print "INFO Firefox\n";
# 				open(MOZILLA, "| $firefox");
# 				$err = $!;
# 			}else{
# 				$err = "not found \nINFO Please copy and paste the URL into your Browser.\n";
# 			}
# 			if($err) {
# 				print "$err\n";
# 				# seek error 
# # 				print "upload done\n"; # PROCESS COMMUNICATION STRING! DO NOT CHANGE!
# # 				exit;
# 			}
# 			sleep 2;
			if($firefox){
				print "INFO $l_ul5 Firefox\n";
				open(MOZILLA, "| $firefox");
				sleep 2;
				`$firefox -remote "openurl($burl)"`;
			}elsif($mozilla){
				open(MOZILLA, "| $mozilla");
				sleep 2;
				print "INFO $l_ul5 Mozilla\n";
				`$mozilla -remote "openurl($burl)"`;
# 		}elsif($firefox){
# 			print "INFO Firefox is not running, starting new\n";
# 			`$firefox "$burl" 2> /dev/null`;
# 		}elsif($mozilla){
# 			print "INFO Mozilla is not running, starting new\n";
# 			# `$mozilla "$burl" 2> /dev/null`;
			}else{ 
				$err = "$l_e9";
			}
			if($err){
				print "INFO $err\nINFO $l_e10\n";
        			print "\n  Please open $burl in your browser.\n";     
			}
		#}
		print "upload done\n"; # PROCESS COMMUNICATION STRING! DO NOT CHANGE!
		exit;
	}elsif ($! =~ /No more process/) {
		warn "Redo fork\n";
        	sleep 5;
        	redo FORK;
	} else {
        	# weird fork error
        	warn "Can't fork: $!\n";
	} 
	1;
}

1;
