#!/usr/bin/perl

$lang = substr($ENV{LANG}, 0, 2);

use vars qw( $lib $l_fil $l_mdi $l_hel $l_mab $l_hco $l_hal $l_hor $l_hla $l_ulh $l_him );

if(-e "$ENV{HOME}/.gtkgallery/sitevariables"){
	require "$ENV{HOME}/.gtkgallery/sitevariables"}
elsif (-e '/etc/gtkgallery/sitevariables' )  {
	require "/etc/gtkgallery/sitevariables";}
else {die "\nNo configuration file found!\n"}
if (-e "$lib/lang") {require "$lib/lang"}
if (-e "$lib/lang.$lang") {require "$lib/lang.$lang"}

$version = "0.51";
$l_auth_mail="jens\@wilke.org";

$f_lb1 = 'Fotokasten GmbH';
$lim1 = "$lib/fotokasten_logo.jpg"; # image f_lb1

@menuitems = (
        [
                "\/$l_fil",
                undef,
                undef,
                undef,
                '<Branch>'
        ],
        [
                "\/$l_fil\/$l_mdi",
                undef,
                undef,
                undef,
                '<Branch>'
        ],
# 	[
#                 "\/$l_fil\/$l_mdi\/$l_ral",
#                 undef,
#                 sub {albumlist('/')},
#                 undef,
#                 '<Item>'
#         ],
        [
                "\/$l_fil\/$l_qui",
                undef,
                sub {exit},
                undef,
                '<Item>'
        ],
        [
                "\/$l_hel",
                undef,
                undef,
                undef,
                '<Branch>',
        ],      [
                "\/$l_hel\/$l_mab",
                undef,
                \&about,
                3,
                '<Item>'
        ],
	[
                "\/$l_hel\/$l_hco",
                undef,
                sub {&help(1)},
                3,
                '<Item>'
        ],
	[
                "\/$l_hel\/$l_hal",
                undef,
		sub {&help(2)},
                3,
                '<Item>'
        ],
	[
                "\/$l_hel\/$l_him",
                undef,
		sub {&help(7)},
                3,
                '<Item>'
        ],	
	[
                "\/$l_hel\/$l_hor",
                undef,
		sub {&help(3)},
                3,
                '<Item>'
        ],
	[
                "\/$l_hel\/$l_hla",
                undef,
		undef,
                3,
                '<Branch>'
        ],
	[
                "\/$l_hel\/$l_hla\/$f_lb1",
                undef,
		sub {&help(4)},
                3,
                '<Item>'
        ],	
	[
                "\/$l_hel\/$l_hla\/Fakelab",
                undef,
		sub {&help(5)},
                3,
                '<Item>'
        ],
	[
                "\/$l_hel\/$l_hla\/$l_ulh",
                undef,
		sub {&help(6)},
                3,
                '<Item>'
        ],
# 	[
#                 '/Help/_Manual',
#                 undef,
#                 \&help,
#                 3,
#                 '<Item>'
#         ],
);
return 1;
