#!/usr/bin/perl

# Nederlands - Dutch
# ver 0.4 Versioning to be adaptet to the corresponding default lang file!
# subver 0.3	independent version of this file

##########################################################

require "$lib/GGvars.pl";
use vars qw( $l_auth_mail );

###########################################################

sub formatdate {
	my ($date,$day, $month, $year) = @_;
	return("$day. $month $year");
}
sub formattime {
	my ($time, $hours,$minutes,$seconds) = @_;
	return ("$hours:$minutes:$seconds")
}

$l_tit = 'GTK Photo Gallery'; # the apps name
$l_alb = 'Album'; 		# label of Tab Album
$l_dir = 'Directory';		# label for tab Directory
$l_pic = 'Foto'; 		# label of column picture
$l_fln = 'Naam'; 		# label of column filename
$l_dsc = 'Omschrijving';	# label of columnDescription
$l_del = 'Verwijderen';		# label of column delete
$l_r90 = 'Draaien 90';		# label of column rotate 90
$l_r18 = '180';		# label of column rotate
$l_r27 = '270';		# label of column rotate
$l_mov = 'Verplaatsen';		# label of column move
$l_dim = 'Omschrijving'; 	# label for image description/exif
$l_unk = 'onbekend';		# if something is "unknown"
$l_sec = 'sec';			# seconds
$l_yes = 'Ja';			# just say "yes"
$l_no  = 'Nee';			# say "no"
@months = ("","Jan","Feb","Mar","Apr","Mei","Jun","Jul","Aug","Sep","Okt","Nov","Dec"); # month starting with an empty field!
$l_at = 'om';			# "at" this time
$l_siz = 'Grootte';		# size
$l_pix = 'beeldpunten';		# pixel
$l_exi = 'Exif gegevens';	# exif data
$l_mak = 'Merk';		# Make
$l_mod = 'Model';		# Model
$l_exp = 'Sluitertijd'; 	# Exposure Time
$l_ape = 'Diafragma';		# Aperture, Blende
$l_foc = 'Brandpunt'; 		# Focal Length
$l_dis = 'Afstand';		# distance
$l_fla = 'Flits gebruikt';	# flash
$l_d_t = 'Datum/tijd';		# Date/Time
$l_dat = 'Datum';
$l_tim = 'Tijd';
$l_dsl = 'Selecteer doeldirectory'; # Destination Selector
$l_sld = 'Selecteer bestemming'; # Select Destination
$l_abo = 'Informatie/Licentie';	 # About
$l_ade = 'Bestand verwijderen?'; # ask for deletion
$l_asl = 'Alles geselecteerd';   # all selected
$l_sli = 'Diashow'; 		 # slideshow

# image viewer

$l_fsc = "Volledig _scherm"; 	# full screen

# Dialogues

$l_dre ="Album wordt ververst"; # refreshing Album
$l_dpw = "Even geduld ...";	# Please wait...
$l_dpf = "Bestanden worden bewerkt ..."; # Processing files...
$l_dpr = "Bewerken";		# Processing 

# vars for order.pm
$l_ord = 'Bestellen';		# order
$l_chl = 'Kies fotocentrale';	# choose Lab..
$l_odn = "_Bestel nu!"; 	# oder now
$l_onr = 'Open bestelling ...';	# Open order .file selection dialogue title
$l_sor = 'Sla bestelling op als ...'; 		# save order as file selection dialogue title
$l_fxt = 'Bestand bestaat al!';	 		# File exists! dialogue title
$l_fxl = 'Bestand bestaat al! Overschrijven?';	# File exists! dialogue label
$l_err = 'Fout!';		# Error!
$l_e1  = "Bestand bestaat maar is geen normaal bestand!"; # File exists but is not a regular file!
$l_e2  = "Bestand bestaat maar is niet beschrijfbaar!";	  # File exists but is not writable!
$l_e3  = "is niet beschrijfbaar!"; 		# is not writable!
$l_for = 'Formaat'; 		# 'Format'
$l_e_c = 'Exact/afknippen';	# exact/crop
$l_num = "Aantal";		# number
$l_ski = 'Weergave';		# skin
$l_bor = 'Rand';		# border
$l_opt = 'Optimalizeren';	# optimize

# menu items
# menuitems should contain underlines for keyboard access
$l_fil = "_Album";		# Menuitem "Album"
$l_qui = "_Einde";		# Menuitem "Quit"
$l_ref = "_Directory overzicht";# Menuitem "Refresh Directory"
$l_mdi = "_Vernieuwen";		# Menuitem "Refresh"
$l_ral = "_Album"; 		# Menuitem "Refresh album"
$l_hel = "_Help";		# "Help"
$l_mab = '_Info... & Licentie';	# About
$l_hco = "_Configuratie";	# configuration
$l_hal = "A_lbum overzicht";	# album view
$l_him = "_Foto viewer";	# image viewer
$l_hor = "_Bestel afdrukken";	# order prints
$l_hla = "_Ontwikkelcentrales";	# help on laboratory
$l_ulh = "_Uw centrale hier";	# how to get labs added to the list

$l_cre = "maken"; 		# create
$l_ren = "hernoemen"; 		# rename
$l_ext = "exporteren"; 		# export
$l_imp = "importeren"; 		# import
$l_ful = "volledige grootte"; 	# full size
$l_dde = "Album verwijderen?";	# Delete album?
$l_dcr = "Album maken";		# Create album

# info label
$l_ihg = "Uw bestelling wordt verwerkt.

Als het versturen afgerond is, zal de website geopend worden met 
Firefox of Mozilla. U kunt dan het bestelproces verder afronden.
Als er een fout optreedt krijgt u een URL in de SHELL te zien; open
deze URL in uw browser om de bestelling af te handelen.
";

# help text

$l_abu = "(c) Jens Wilke 2003 - 2006
http://photo.wilke.org/gtk-gallery
 
 Dit programma is verspreid onder de voorwaarden van de GNU General Public License.
Zie het bijgesloten bestand LICENSE. Als u niet akkoord gaat met deze voorwaarden,
dan mag u $l_tit niet gebruiken of verspreiden.
 \n"; # about dialogue

$l_hlp[1] = "
U dient $l_tit te configureren alvorens u het kunt gebruiken.

Globale configuratie dient door de gebruiker root gedaan te worden in het bestand
/etc/gtkgallery/sitevariables. Dit bestand is tot op detailniveau gedocumenteerd.
De site-images directory dient gekopieerd te worden van $l_tit naar elke \$dataroot
directory! Gebruikers kunnen hun persoonlijke configuratie gebruiken door het bestand
/etc/gtkgallery/sitevariables naar \$HOME/.gtkgallery/sitevariables te kopieren en 
aan te passen naar eigen wens. (\$HOME is de homedirectory van de gebruiker.)
\nHuidige \$dataroot is $dataroot.
\n";	# configuration

$l_hlp[2] ="
Album overzicht
------------------------

Het linker venster toont de directory die u heeft ingesteld als \$photoroot in de configuratie.
Klik in dit venster op de rechtermuisknop om albums aan te maken, te hernoemen, te verwijderen, 
te importeren of te exporteren (zie beneden).

Het rechter venster bevat de inhoud van de gekozen directory. U kunt hier meerdere bewerkingen
tegelijkertijd per foto opgeven. Voeg de omschrijving toe door op het \'omschrijving\' veld te 
klikken. Begin een nieuwe regel met <Ctrl>+<Return>.
Wijzigingen worden alleen doorgevoerd als op de \'Toepassen\' knop onderaan het venster gedrukt
 wordt.

Met een druk op de \'F\'-toets schakelt u naar een volledig scherm. In het volledig scherm
gebruikt u de volgende toetsen:

\'Q'\ of \'<ESC>\'	sluit volledig scherm
\'<-\'				vorige foto
\'->\'				volgende foto
\'O\'				open foto met de Gimp
 
Dubbelklikken op een foto opent deze in een nieuw venster waarbij de EXIF gegevens van de 
foto getoond worden. Tevens kunt u hier bladeren door de directorystructuur en de foto's openen
in \'De Gimp\'.

De miniatuurweergaven (en andere fotoformaten) worden automatisch aangemaakt indien ze benodigd 
zijn. U kunt dit proces ook vooraf handmatig uitvoeren met het script createfiles. Dit bespaart
wat tijd tijdens het gebruik van het programma. Instructies: 
\'cd /usr/local/lib/gtkgallery\'
\'./createfiles --h\' voor help

Exporteren/importeren:
Deze onderdelen zijn nog experimenteel. Lees het BUGS bestand.
Rechtsklikken met de muis in de albumstructuur biedt de mogelijkheid om albums te importeren
en exporteren. Selecteer de formaten van de foto's en kies een directory waar het album naar
geexporteerd wordt.  Daar wordt het album opgedeeld in stukken van circa 700 MB in meerdere
subdirectories met de namen part1, part2 enz. Deze kunnen direct op een CD gebrand worden.
De delen bevatten index.html bestanden die met een web browser geopend kunnen worden.

Een export kan weer geimporteerd worden door een van de part* directories als import source 
op te geven.

\n\n"; # Album view

$l_hlp[3] = "
Hoe kunt u afdrukken bestellen?
----------------------------------------------

Drag&drop de foto's van elk album naar de \'Bestelling\' tab.\nSchakel over naar de \'Bestelling\' tab
en kies eerst een laboratorium (ontwikkelcentrale). Vervolgens volgt u de instructies voor het gekozen
laboratorium. De landen waar de laboratoria de foto's naar versturen staan tussen rechte haken achter
de naam aangegeven. Meer details vindt u in Help > Laboratoria.

U GAAT VOOR DE AFDRUKKEN EEN CONTRACT AAN MET DE ONTWIKKELCENTRALE, EN NIET MET DE AUTEUR VAN $l_tit
ZODRA U DE \'Uitvoeren\' KNOP INDRUKT!
DE AUTEUR VAN $l_tit IS NIET AANSPRAKELIJK VOOR ALLES WAT MET DIT CONTRACT TE MAKEN HEEFT!

U kunt de bestelling voor later gebruik opslaan. Hierbij worden de paden naar de bestanden en uw
selecties hierbij bewaard. De bestanden zelf worden daarbij niet bewaard (deze blijven op de oorspronkelijke
plaats staan).
\n"; # order view

$l_hlp[4] = "
Fotokasten GmbH 
Zie de website voor details: http://www.fotokasten.[de|fr|nl|se]
Dit bedrijf is gelegen in Stuttgart/Germany en verstuurt wereldwijd.

$l_tit zal de gekozen foto's opsturen naar hun website.
De bestanden zullen verkleind worden naar de grootte die u heeft gekozen, met een JPEG compressie van 90%,
om het dataverkeer te verlagen.
Bij afmetingen boven 20X zullen de ongewijzigde bestanden verstuurd worden.

Als Mozilla of Firefox in uw PATH variabele staan, kan de website automatisch in uw browser geopend
worden. In de overige gevallen wordt de URL weergegeven in de SHELL.
";

$l_hlp[5] = "
De luie medewerkers van Fakelab versturen geen orders. Fakelab toont slechts de mogelijkheden van $l_tit.
";

$l_hlp[6] = "
Als uw ontwikkelcentrale hier niet weergegeven is en u ziet daar graag verandering in komen,
neem dan contact op met de auteur: $l_auth_mail. 
";

$l_hlp[7] = "
Foto viewer
--------------------

Een dubbelklik opent de foto in een nieuw venster. De standaard afmeting wordt ingesteld
in de variabele \$dfsz in het configuratiebestand. De EXIF gegevens van de foto worden
weergegeven naast de afbeelding en u kunt door de directorystructuur bladeren. Verder kunt
u de foto openen en bewerken in \'De Gimp\'.

";

1;
